/*
    Project: TCGINA
    Version: V1.18
    File   : secmem.h

    Copyright (c) 2005-2008 Author of TCGINA DLL. All rights reserved.
    Public Key Fingerprint: 294B A769 4A0A CC05 DAE6 00DD FF47 8C72 4097 67CE

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCGINA binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#ifndef __SECMEM_H_D47DF546F16B490bA6D8523603A5594D
#define __SECMEM_H_D47DF546F16B490bA6D8523603A5594D

#ifdef SEC_DEBUG
typedef struct
{
    unsigned cAllocations;
    size_t   cbAllocationSize;
    unsigned cMaxAllocations;
    size_t   cbMaxAllocationSize;
} SEC_HEAP_INFORMATION, *PSEC_HEAP_INFORMATION;
#endif

#ifdef __cplusplus
extern "C" {
#endif

int sec_heap_init(void);
void sec_heap_destroy(void);

#define SEC_KEEP_MODE -1
#define SEC_FAIL_ON_LOCK_ERROR 0
#define SEC_IGNORE_LOCK_ERRORS 1
int sec_heap_mode(int new_mode);

void * sec_malloc(size_t size);
void * sec_calloc(size_t num, size_t size);
void * sec_realloc(void *p, size_t new_size);
void sec_free(void *p);
void sec_heap_compact(void);

#ifdef SEC_DEBUG
int sec_heap_status(PSEC_HEAP_INFORMATION pshi);
#endif

void sec_memset(void *, char, size_t);

#ifdef __cplusplus
}
#endif

#define sec_alloc(p) ((*((void**)&p) = sec_malloc(sizeof(*p))) != NULL)

#endif
